diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-includes/pomo/streams.php ./wordpress-3.3/wp-includes/pomo/streams.php
*** ./wordpress-3.2.1/wp-includes/pomo/streams.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-includes/pomo/streams.php	2011-08-10 23:29:35.000000000 -0500
***************
*** 3,28 ****
   * Classes, which help reading streams of data from files.
   * Based on the classes from Danilo Segan <danilo@kvota.net>
   *
!  * @version $Id: streams.php 406 2010-02-07 11:10:24Z nbachiyski $
   * @package pomo
   * @subpackage streams
   */
  
  if ( !class_exists( 'POMO_Reader' ) ):
  class POMO_Reader {
! 
  	var $endian = 'little';
  	var $_post = '';
! 
  	function POMO_Reader() {
  		$this->is_overloaded = ((ini_get("mbstring.func_overload") & 2) != 0) && function_exists('mb_substr');
  		$this->_pos = 0;
  	}
! 
  	/**
  	 * Sets the endianness of the file.
  	 *
! 	 * @param string $endian 'big' or 'little'
  	 */
  	function setEndian($endian) {
  		$this->endian = $endian;
--- 3,28 ----
   * Classes, which help reading streams of data from files.
   * Based on the classes from Danilo Segan <danilo@kvota.net>
   *
!  * @version $Id: streams.php 597 2011-01-16 20:14:36Z nbachiyski $
   * @package pomo
   * @subpackage streams
   */
  
  if ( !class_exists( 'POMO_Reader' ) ):
  class POMO_Reader {
! 	
  	var $endian = 'little';
  	var $_post = '';
! 	
  	function POMO_Reader() {
  		$this->is_overloaded = ((ini_get("mbstring.func_overload") & 2) != 0) && function_exists('mb_substr');
  		$this->_pos = 0;
  	}
! 	
  	/**
  	 * Sets the endianness of the file.
  	 *
! 	 * @param $endian string 'big' or 'little'
  	 */
  	function setEndian($endian) {
  		$this->endian = $endian;
***************
*** 57,64 ****
  		$endian_letter = ('big' == $this->endian)? 'N' : 'V';
  		return unpack($endian_letter.$count, $bytes);
  	}
! 
! 
  	function substr($string, $start, $length) {
  		if ($this->is_overloaded) {
  			return mb_substr($string, $start, $length, 'ascii');
--- 57,64 ----
  		$endian_letter = ('big' == $this->endian)? 'N' : 'V';
  		return unpack($endian_letter.$count, $bytes);
  	}
! 	
! 	
  	function substr($string, $start, $length) {
  		if ($this->is_overloaded) {
  			return mb_substr($string, $start, $length, 'ascii');
***************
*** 66,72 ****
  			return substr($string, $start, $length);
  		}
  	}
! 
  	function strlen($string) {
  		if ($this->is_overloaded) {
  			return mb_strlen($string, 'ascii');
--- 66,72 ----
  			return substr($string, $start, $length);
  		}
  	}
! 	
  	function strlen($string) {
  		if ($this->is_overloaded) {
  			return mb_strlen($string, 'ascii');
***************
*** 74,80 ****
  			return strlen($string);
  		}
  	}
! 
  	function str_split($string, $chunk_size) {
  		if (!function_exists('str_split')) {
  			$length = $this->strlen($string);
--- 74,80 ----
  			return strlen($string);
  		}
  	}
! 	
  	function str_split($string, $chunk_size) {
  		if (!function_exists('str_split')) {
  			$length = $this->strlen($string);
***************
*** 86,93 ****
  			return str_split( $string, $chunk_size );
  		}
  	}
! 
! 
  	function pos() {
  		return $this->_pos;
  	}
--- 86,93 ----
  			return str_split( $string, $chunk_size );
  		}
  	}
! 	
! 		
  	function pos() {
  		return $this->_pos;
  	}
***************
*** 95,101 ****
  	function is_resource() {
  		return true;
  	}
! 
  	function close() {
  		return true;
  	}
--- 95,101 ----
  	function is_resource() {
  		return true;
  	}
! 	
  	function close() {
  		return true;
  	}
***************
*** 106,118 ****
  class POMO_FileReader extends POMO_Reader {
  	function POMO_FileReader($filename) {
  		parent::POMO_Reader();
! 		$this->_f = fopen($filename, 'r');
  	}
! 
  	function read($bytes) {
  		return fread($this->_f, $bytes);
  	}
! 
  	function seekto($pos) {
  		if ( -1 == fseek($this->_f, $pos, SEEK_SET)) {
  			return false;
--- 106,118 ----
  class POMO_FileReader extends POMO_Reader {
  	function POMO_FileReader($filename) {
  		parent::POMO_Reader();
! 		$this->_f = fopen($filename, 'rb');
  	}
! 	
  	function read($bytes) {
  		return fread($this->_f, $bytes);
  	}
! 	
  	function seekto($pos) {
  		if ( -1 == fseek($this->_f, $pos, SEEK_SET)) {
  			return false;
***************
*** 120,138 ****
  		$this->_pos = $pos;
  		return true;
  	}
! 
  	function is_resource() {
  		return is_resource($this->_f);
  	}
! 
  	function feof() {
  		return feof($this->_f);
  	}
! 
  	function close() {
  		return fclose($this->_f);
  	}
! 
  	function read_all() {
  		$all = '';
  		while ( !$this->feof() )
--- 120,138 ----
  		$this->_pos = $pos;
  		return true;
  	}
! 	
  	function is_resource() {
  		return is_resource($this->_f);
  	}
! 	
  	function feof() {
  		return feof($this->_f);
  	}
! 	
  	function close() {
  		return fclose($this->_f);
  	}
! 	
  	function read_all() {
  		$all = '';
  		while ( !$this->feof() )
***************
*** 148,156 ****
   * of a physical file.
   */
  class POMO_StringReader extends POMO_Reader {
! 
  	var $_str = '';
! 
  	function POMO_StringReader($str = '') {
  		parent::POMO_Reader();
  		$this->_str = $str;
--- 148,156 ----
   * of a physical file.
   */
  class POMO_StringReader extends POMO_Reader {
! 	
  	var $_str = '';
! 	
  	function POMO_StringReader($str = '') {
  		parent::POMO_Reader();
  		$this->_str = $str;
***************
*** 178,184 ****
  	function read_all() {
  		return $this->substr($this->_str, $this->_pos, $this->strlen($this->_str));
  	}
! 
  }
  endif;
  
--- 178,184 ----
  	function read_all() {
  		return $this->substr($this->_str, $this->_pos, $this->strlen($this->_str));
  	}
! 	
  }
  endif;
  
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-includes/pomo/translations.php ./wordpress-3.3/wp-includes/pomo/translations.php
*** ./wordpress-3.2.1/wp-includes/pomo/translations.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-includes/pomo/translations.php	2011-09-29 17:57:43.000000000 -0500
***************
*** 2,8 ****
  /**
   * Class for a set of entries for translation and their associated headers
   *
!  * @version $Id: translations.php 406 2010-02-07 11:10:24Z nbachiyski $
   * @package pomo
   * @subpackage translations
   */
--- 2,8 ----
  /**
   * Class for a set of entries for translation and their associated headers
   *
!  * @version $Id: translations.php 590 2010-12-20 19:58:37Z nbachiyski $
   * @package pomo
   * @subpackage translations
   */
***************
*** 29,34 ****
--- 29,47 ----
  		$this->entries[$key] = &$entry;
  		return true;
  	}
+ 	
+ 	function add_entry_or_merge($entry) {
+ 		if (is_array($entry)) {
+ 			$entry = new Translation_Entry($entry);
+ 		}
+ 		$key = $entry->key();
+ 		if (false === $key) return false;
+ 		if (isset($this->entries[$key]))
+ 			$this->entries[$key]->merge_with($entry);
+ 		else
+ 			$this->entries[$key] = &$entry;
+ 		return true;
+ 	}
  
  	/**
  	 * Sets $header PO header to $value
***************
*** 68,74 ****
  	/**
  	 * Given the number of items, returns the 0-based index of the plural form to use
  	 *
! 	 * Here, in the base Translations class, the commong logic for English is implmented:
  	 * 	0 if there is one element, 1 otherwise
  	 *
  	 * This function should be overrided by the sub-classes. For example MO/PO can derive the logic
--- 81,87 ----
  	/**
  	 * Given the number of items, returns the 0-based index of the plural form to use
  	 *
! 	 * Here, in the base Translations class, the common logic for English is implemented:
  	 * 	0 if there is one element, 1 otherwise
  	 *
  	 * This function should be overrided by the sub-classes. For example MO/PO can derive the logic
***************
*** 108,113 ****
--- 121,135 ----
  			$this->entries[$entry->key()] = $entry;
  		}
  	}
+ 	
+ 	function merge_originals_with(&$other) {
+ 		foreach( $other->entries as $entry ) {
+ 			if ( !isset( $this->entries[$entry->key()] ) )
+ 				$this->entries[$entry->key()] = $entry;
+ 			else
+ 				$this->entries[$entry->key()]->merge_with($entry);
+ 		}
+ 	}
  }
  
  class Gettext_Translations extends Translations {
***************
*** 126,132 ****
  		}
  		return call_user_func($this->_gettext_select_plural_form, $count);
  	}
! 
  	function nplurals_and_expression_from_header($header) {
  		if (preg_match('/^\s*nplurals\s*=\s*(\d+)\s*;\s+plural\s*=\s*(.+)$/', $header, $matches)) {
  			$nplurals = (int)$matches[1];
--- 148,154 ----
  		}
  		return call_user_func($this->_gettext_select_plural_form, $count);
  	}
! 	
  	function nplurals_and_expression_from_header($header) {
  		if (preg_match('/^\s*nplurals\s*=\s*(\d+)\s*;\s+plural\s*=\s*(.+)$/', $header, $matches)) {
  			$nplurals = (int)$matches[1];
***************
*** 152,158 ****
  	/**
  	 * Adds parantheses to the inner parts of ternary operators in
  	 * plural expressions, because PHP evaluates ternary oerators from left to right
! 	 *
  	 * @param string $expression the expression without parentheses
  	 * @return string the expression with parentheses added
  	 */
--- 174,180 ----
  	/**
  	 * Adds parantheses to the inner parts of ternary operators in
  	 * plural expressions, because PHP evaluates ternary oerators from left to right
! 	 * 
  	 * @param string $expression the expression without parentheses
  	 * @return string the expression with parentheses added
  	 */
***************
*** 180,186 ****
  		}
  		return rtrim($res, ';');
  	}
! 
  	function make_headers($translation) {
  		$headers = array();
  		// sometimes \ns are used instead of real new lines
--- 202,208 ----
  		}
  		return rtrim($res, ';');
  	}
! 	
  	function make_headers($translation) {
  		$headers = array();
  		// sometimes \ns are used instead of real new lines
***************
*** 193,199 ****
  		}
  		return $headers;
  	}
! 
  	function set_header($header, $value) {
  		parent::set_header($header, $value);
  		if ('Plural-Forms' == $header) {
--- 215,221 ----
  		}
  		return $headers;
  	}
! 	
  	function set_header($header, $value) {
  		parent::set_header($header, $value);
  		if ('Plural-Forms' == $header) {
***************
*** 212,218 ****
  class NOOP_Translations {
  	var $entries = array();
  	var $headers = array();
! 
  	function add_entry($entry) {
  		return true;
  	}
--- 234,240 ----
  class NOOP_Translations {
  	var $entries = array();
  	var $headers = array();
! 	
  	function add_entry($entry) {
  		return true;
  	}
diff -crBPN --exclude=wp-config.php --exclude=.htaccess-inst --exclude=wordpress.sql --exclude=.htaccess.inst --exclude=wp-config.php --exclude=wordpress.sql --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.3.pl ./wordpress-3.2.1/wp-includes/post.php ./wordpress-3.3/wp-includes/post.php
*** ./wordpress-3.2.1/wp-includes/post.php	2011-11-24 20:39:26.000000000 -0600
--- ./wordpress-3.3/wp-includes/post.php	2011-11-23 18:20:21.000000000 -0600
***************
*** 51,56 ****
--- 51,57 ----
  	register_post_type( 'attachment', array(
  		'labels' => array(
  			'name' => __( 'Media' ),
+ 			'edit_item' => __( 'Edit Media' ),
  		),
  		'public' => true,
  		'show_ui' => false,
***************
*** 380,385 ****
--- 381,388 ----
  		_get_post_ancestors($post);
  		$_post = sanitize_post($post, 'raw');
  		wp_cache_add($post->ID, $_post, 'posts');
+ 	} elseif ( is_object($post) && 'raw' == $post->filter ) {
+ 		$_post = $post;
  	} else {
  		if ( is_object($post) )
  			$post_id = $post->ID;
***************
*** 433,439 ****
  /**
   * Retrieve data from a post field based on Post ID.
   *
!  * Examples of the post field will be, 'post_type', 'post_status', 'content',
   * etc and based off of the post object property or key names.
   *
   * The context values are based off of the taxonomy filter functions and
--- 436,442 ----
  /**
   * Retrieve data from a post field based on Post ID.
   *
!  * Examples of the post field will be, 'post_type', 'post_status', 'post_content',
   * etc and based off of the post object property or key names.
   *
   * The context values are based off of the taxonomy filter functions and
***************
*** 985,991 ****
  		$wp->add_query_var($args->query_var);
  	}
  
! 	if ( false !== $args->rewrite && '' != get_option('permalink_structure') ) {
  		if ( ! is_array( $args->rewrite ) )
  			$args->rewrite = array();
  		if ( empty( $args->rewrite['slug'] ) )
--- 988,994 ----
  		$wp->add_query_var($args->query_var);
  	}
  
! 	if ( false !== $args->rewrite && ( is_admin() || '' != get_option('permalink_structure') ) ) {
  		if ( ! is_array( $args->rewrite ) )
  			$args->rewrite = array();
  		if ( empty( $args->rewrite['slug'] ) )
***************
*** 1036,1041 ****
--- 1039,1046 ----
  		register_taxonomy_for_object_type( $taxonomy, $post_type );
  	}
  
+ 	do_action( 'registered_post_type', $post_type, $args );
+ 
  	return $args;
  }
  
***************
*** 1154,1160 ****
   * Builds an object with all post type labels out of a post type object
   *
   * Accepted keys of the label array in the post type object:
!  * - name - general name for the post type, usually plural. The same and overriden by $post_type_object->label. Default is Posts/Pages
   * - singular_name - name for one object of this post type. Default is Post/Page
   * - add_new - Default is Add New for both hierarchical and non-hierarchical types. When internationalizing this string, please use a {@link http://codex.wordpress.org/I18n_for_WordPress_Developers#Disambiguation_by_context gettext context} matching your post type. Example: <code>_x('Add New', 'product');</code>
   * - add_new_item - Default is Add New Post/Add New Page
--- 1159,1165 ----
   * Builds an object with all post type labels out of a post type object
   *
   * Accepted keys of the label array in the post type object:
!  * - name - general name for the post type, usually plural. The same and overridden by $post_type_object->label. Default is Posts/Pages
   * - singular_name - name for one object of this post type. Default is Post/Page
   * - add_new - Default is Add New for both hierarchical and non-hierarchical types. When internationalizing this string, please use a {@link http://codex.wordpress.org/I18n_for_WordPress_Developers#Disambiguation_by_context gettext context} matching your post type. Example: <code>_x('Add New', 'product');</code>
   * - add_new_item - Default is Add New Post/Add New Page
***************
*** 1165,1170 ****
--- 1170,1177 ----
   * - not_found - Default is No posts found/No pages found
   * - not_found_in_trash - Default is No posts found in Trash/No pages found in Trash
   * - parent_item_colon - This string isn't used on non-hierarchical types. In hierarchical ones the default is Parent Page:
+  * - all_items - String for the submenu. Default is All Posts/All Pages
+  * - menu_name - Default is the same as <code>name</code>
   *
   * Above, the first default value is for non-hierarchical post types (like posts) and the second one is for hierarchical post types (like pages).
   *
***************
*** 1246,1252 ****
   * 'excerpt', 'page-attributes', 'thumbnail', and 'custom-fields'.
   *
   * Additionally, the 'revisions' feature dictates whether the post type will store revisions,
!  * and the 'comments' feature dicates whether the comments count will show on the edit screen.
   *
   * @since 3.0.0
   * @param string $post_type The post type for which to add the feature
--- 1253,1259 ----
   * 'excerpt', 'page-attributes', 'thumbnail', and 'custom-fields'.
   *
   * Additionally, the 'revisions' feature dictates whether the post type will store revisions,
!  * and the 'comments' feature dictates whether the comments count will show on the edit screen.
   *
   * @since 3.0.0
   * @param string $post_type The post type for which to add the feature
***************
*** 1495,1516 ****
   * @return bool Whether the post meta key was deleted from the database
   */
  function delete_post_meta_by_key($post_meta_key) {
! 	if ( !$post_meta_key )
! 		return false;
! 
! 	global $wpdb;
! 	$post_ids = $wpdb->get_col($wpdb->prepare("SELECT DISTINCT post_id FROM $wpdb->postmeta WHERE meta_key = %s", $post_meta_key));
! 	if ( $post_ids ) {
! 		$postmetaids = $wpdb->get_col( $wpdb->prepare( "SELECT meta_id FROM $wpdb->postmeta WHERE meta_key = %s", $post_meta_key ) );
! 		$in = implode( ',', array_fill(1, count($postmetaids), '%d'));
! 		do_action( 'delete_postmeta', $postmetaids );
! 		$wpdb->query( $wpdb->prepare("DELETE FROM $wpdb->postmeta WHERE meta_id IN($in)", $postmetaids ));
! 		do_action( 'deleted_postmeta', $postmetaids );
! 		foreach ( $post_ids as $post_id )
! 			wp_cache_delete($post_id, 'post_meta');
! 		return true;
! 	}
! 	return false;
  }
  
  /**
--- 1502,1508 ----
   * @return bool Whether the post meta key was deleted from the database
   */
  function delete_post_meta_by_key($post_meta_key) {
! 	return delete_metadata( 'post', null, $post_meta_key, '', true );
  }
  
  /**
***************
*** 2083,2089 ****
  	if ( $post['post_status'] == 'trash' )
  		return false;
  
! 	do_action('trash_post', $post_id);
  
  	add_post_meta($post_id,'_wp_trash_meta_status', $post['post_status']);
  	add_post_meta($post_id,'_wp_trash_meta_time', time());
--- 2075,2081 ----
  	if ( $post['post_status'] == 'trash' )
  		return false;
  
! 	do_action('wp_trash_post', $post_id);
  
  	add_post_meta($post_id,'_wp_trash_meta_status', $post['post_status']);
  	add_post_meta($post_id,'_wp_trash_meta_time', time());
***************
*** 2447,2455 ****
  		$previous_status = 'new';
  	}
  
! 	if ( ('' == $post_content) && ('' == $post_title) && ('' == $post_excerpt) && ('attachment' != $post_type) ) {
  		if ( $wp_error )
! 			return new WP_Error('empty_content', __('Content, title, and excerpt are empty.'));
  		else
  			return 0;
  	}
--- 2439,2449 ----
  		$previous_status = 'new';
  	}
  
! 	$maybe_empty = ! $post_content && ! $post_title && ! $post_excerpt && post_type_supports( $post_type, 'editor' )
! 		&& post_type_supports( $post_type, 'title' ) && post_type_supports( $post_type, 'excerpt' );
! 	if ( apply_filters( 'wp_insert_post_empty_content', $maybe_empty, $postarr ) ) {
  		if ( $wp_error )
! 			return new WP_Error( 'empty_content', __( 'Content, title, and excerpt are empty.' ) );
  		else
  			return 0;
  	}
***************
*** 2496,2502 ****
  		else
  			$post_name = '';
  	} else {
! 		$post_name = sanitize_title($post_name);
  	}
  
  	// If the post date is empty (due to having been new or a draft) and status is not 'draft' or 'pending', set date to now
--- 2490,2501 ----
  		else
  			$post_name = '';
  	} else {
! 		// On updates, we need to check to see if it's using the old, fixed sanitization context.
! 		$check_name = sanitize_title( $post_name, '', 'old-save' );
! 		if ( $update && strtolower( urlencode( $post_name ) ) == $check_name && get_post_field( 'post_name', $ID ) == $check_name )
! 			$post_name = $check_name;
! 		else // new post, or slug has changed.
! 			$post_name = sanitize_title($post_name);
  	}
  
  	// If the post date is empty (due to having been new or a draft) and status is not 'draft' or 'pending', set date to now
***************
*** 2739,2750 ****
  	$post->post_status = 'publish';
  	wp_transition_post_status('publish', $old_status, $post);
  
- 	// Update counts for the post's terms.
- 	foreach ( (array) get_object_taxonomies('post') as $taxonomy ) {
- 		$tt_ids = wp_get_object_terms($post_id, $taxonomy, array('fields' => 'tt_ids'));
- 		wp_update_term_count($tt_ids, $taxonomy);
- 	}
- 
  	do_action('edit_post', $post_id, $post);
  	do_action('save_post', $post_id, $post);
  	do_action('wp_insert_post', $post_id, $post);
--- 2738,2743 ----
***************
*** 2853,2859 ****
  		}
  	}
  
! 	return $slug;
  }
  
  /**
--- 2846,2852 ----
  		}
  	}
  
! 	return apply_filters( 'wp_unique_post_slug', $slug, $post_ID, $post_status, $post_type, $post_parent );
  }
  
  /**
***************
*** 3159,3196 ****
   */
  function get_page_by_path($page_path, $output = OBJECT, $post_type = 'page') {
  	global $wpdb;
! 	$null = null;
  	$page_path = rawurlencode(urldecode($page_path));
  	$page_path = str_replace('%2F', '/', $page_path);
  	$page_path = str_replace('%20', ' ', $page_path);
! 	$page_paths = '/' . trim($page_path, '/');
! 	$leaf_path  = sanitize_title(basename($page_paths));
! 	$page_paths = explode('/', $page_paths);
! 	$full_path = '';
! 	foreach ( (array) $page_paths as $pathdir )
! 		$full_path .= ( $pathdir != '' ? '/' : '' ) . sanitize_title($pathdir);
  
! 	$pages = $wpdb->get_results( $wpdb->prepare( "SELECT ID, post_name, post_parent FROM $wpdb->posts WHERE post_name = %s AND (post_type = %s OR post_type = 'attachment')", $leaf_path, $post_type ));
  
! 	if ( empty($pages) )
! 		return $null;
  
! 	foreach ( $pages as $page ) {
! 		$path = '/' . $leaf_path;
! 		$curpage = $page;
! 		while ( $curpage->post_parent != 0 ) {
! 			$post_parent = $curpage->post_parent;
! 			$curpage = wp_cache_get( $post_parent, 'posts' );
! 			if ( false === $curpage )
! 				$curpage = $wpdb->get_row( $wpdb->prepare( "SELECT ID, post_name, post_parent FROM $wpdb->posts WHERE ID = %d and post_type = %s", $post_parent, $post_type ) );
! 			$path = '/' . $curpage->post_name . $path;
  		}
- 
- 		if ( $path == $full_path )
- 			return get_page($page->ID, $output, $post_type);
  	}
  
! 	return $null;
  }
  
  /**
--- 3152,3196 ----
   */
  function get_page_by_path($page_path, $output = OBJECT, $post_type = 'page') {
  	global $wpdb;
! 
  	$page_path = rawurlencode(urldecode($page_path));
  	$page_path = str_replace('%2F', '/', $page_path);
  	$page_path = str_replace('%20', ' ', $page_path);
! 	$parts = explode( '/', trim( $page_path, '/' ) );
! 	$parts = array_map( 'esc_sql', $parts );
! 	$parts = array_map( 'sanitize_title_for_query', $parts );
! 
! 	$in_string = "'". implode( "','", $parts ) . "'";
! 	$post_type_sql = $post_type;
! 	$wpdb->escape_by_ref( $post_type_sql );
! 	$pages = $wpdb->get_results( "SELECT ID, post_name, post_parent FROM $wpdb->posts WHERE post_name IN ($in_string) AND (post_type = '$post_type_sql' OR post_type = 'attachment')", OBJECT_K );
  
! 	$revparts = array_reverse( $parts );
  
! 	$foundid = 0;
! 	foreach ( (array) $pages as $page ) {
! 		if ( $page->post_name == $revparts[0] ) {
! 			$count = 0;
! 			$p = $page;
! 			while ( $p->post_parent != 0 && isset( $pages[ $p->post_parent ] ) ) {
! 				$count++;
! 				$parent = $pages[ $p->post_parent ];
! 				if ( ! isset( $revparts[ $count ] ) || $parent->post_name != $revparts[ $count ] )
! 					break;
! 				$p = $parent;
! 			}
  
! 			if ( $p->post_parent == 0 && $count+1 == count( $revparts ) && $p->post_name == $revparts[ $count ] ) {
! 				$foundid = $page->ID;
! 				break;
! 			}
  		}
  	}
  
! 	if ( $foundid )
! 		return get_page( $foundid, $output );
! 
! 	return null;
  }
  
  /**
***************
*** 3270,3276 ****
  
  /**
   * function to traverse and return all the nested children post names of a root page.
!  * $children contains parent-chilren relations
   *
   * @since 2.9.0
   */
--- 3270,3276 ----
  
  /**
   * function to traverse and return all the nested children post names of a root page.
!  * $children contains parent-children relations
   *
   * @since 2.9.0
   */
***************
*** 3408,3414 ****
  			foreach ( $post_authors as $post_author ) {
  				//Do we have an author id or an author login?
  				if ( 0 == intval($post_author) ) {
! 					$post_author = get_userdatabylogin($post_author);
  					if ( empty($post_author) )
  						continue;
  					if ( empty($post_author->ID) )
--- 3408,3414 ----
  			foreach ( $post_authors as $post_author ) {
  				//Do we have an author id or an author login?
  				if ( 0 == intval($post_author) ) {
! 					$post_author = get_user_by('login', $post_author);
  					if ( empty($post_author) )
  						continue;
  					if ( empty($post_author->ID) )
***************
*** 3452,3458 ****
  	}
  
  	$orderby_array = array();
! 	$allowed_keys = array('author', 'post_author', 'date', 'post_date', 'title', 'post_title', 'modified',
  						  'post_modified', 'modified_gmt', 'post_modified_gmt', 'menu_order', 'parent', 'post_parent',
  						  'ID', 'rand', 'comment_count');
  	foreach ( explode( ',', $sort_column ) as $orderby ) {
--- 3452,3458 ----
  	}
  
  	$orderby_array = array();
! 	$allowed_keys = array('author', 'post_author', 'date', 'post_date', 'title', 'post_title', 'name', 'post_name', 'modified',
  						  'post_modified', 'modified_gmt', 'post_modified_gmt', 'menu_order', 'parent', 'post_parent',
  						  'ID', 'rand', 'comment_count');
  	foreach ( explode( ',', $sort_column ) as $orderby ) {
***************
*** 3727,3735 ****
  
  	clean_post_cache($post_ID);
  
- 	if ( isset($post_parent) && $post_parent < 0 )
- 		add_post_meta($post_ID, '_wp_attachment_temp_parent', $post_parent, true);
- 
  	if ( ! empty( $context ) )
  		add_post_meta( $post_ID, '_wp_attachment_context', $context, true );
  
--- 3727,3732 ----
***************
*** 3900,3905 ****
--- 3897,3905 ----
  	if ( !$post =& get_post( $post_id ) )
  		return false;
  
+ 	if ( 'attachment' != $post->post_type )
+ 		return false;
+ 
  	$url = '';
  	if ( $file = get_post_meta( $post->ID, '_wp_attached_file', true) ) { //Get attached file
  		if ( ($uploads = wp_upload_dir()) && false === $uploads['error'] ) { //Get upload directory
***************
*** 3912,3923 ****
  		}
  	}
  
! 	if ( empty($url) ) //If any of the above options failed, Fallback on the GUID as used pre-2.7, not recomended to rely upon this.
  		$url = get_the_guid( $post->ID );
  
  	$url = apply_filters( 'wp_get_attachment_url', $url, $post->ID );
  
! 	if ( 'attachment' != $post->post_type || empty( $url ) )
  		return false;
  
  	return $url;
--- 3912,3923 ----
  		}
  	}
  
! 	if ( empty($url) ) //If any of the above options failed, Fallback on the GUID as used pre-2.7, not recommended to rely upon this.
  		$url = get_the_guid( $post->ID );
  
  	$url = apply_filters( 'wp_get_attachment_url', $url, $post->ID );
  
! 	if ( empty( $url ) )
  		return false;
  
  	return $url;
***************
*** 4037,4043 ****
  			$dirs = apply_filters( 'icon_dirs', array($icon_dir => $icon_dir_uri) );
  			$icon_files = array();
  			while ( $dirs ) {
! 				$dir = array_shift($keys = array_keys($dirs));
  				$uri = array_shift($dirs);
  				if ( $dh = opendir($dir) ) {
  					while ( false !== $file = readdir($dh) ) {
--- 4037,4044 ----
  			$dirs = apply_filters( 'icon_dirs', array($icon_dir => $icon_dir_uri) );
  			$icon_files = array();
  			while ( $dirs ) {
! 				$keys = array_keys( $dirs );
! 				$dir = array_shift( $keys );
  				$uri = array_shift($dirs);
  				if ( $dh = opendir($dir) ) {
  					while ( false !== $file = readdir($dh) ) {
***************
*** 4159,4165 ****
  	// Private posts
  	$post_type_obj = get_post_type_object( $post_type );
  	if ( ! $post_type_obj )
! 		return ' 1 = 0 ';
  
  	// This hook is deprecated. Why you'd want to use it, I dunno.
  	if ( ! $cap = apply_filters( 'pub_priv_sql_capability', '' ) )
--- 4160,4166 ----
  	// Private posts
  	$post_type_obj = get_post_type_object( $post_type );
  	if ( ! $post_type_obj )
! 		return $full ? 'WHERE 1 = 0' : ' 1 = 0 ';
  
  	// This hook is deprecated. Why you'd want to use it, I dunno.
  	if ( ! $cap = apply_filters( 'pub_priv_sql_capability', '' ) )
***************
*** 4467,4473 ****
  /**
   * Will clean the attachment in the cache.
   *
!  * Cleaning means delete from the cache. Optionaly will clean the term
   * object cache associated with the attachment ID.
   *
   * This function will not run if $_wp_suspend_cache_invalidation is not empty. See
--- 4468,4474 ----
  /**
   * Will clean the attachment in the cache.
   *
!  * Cleaning means delete from the cache. Optionally will clean the term
   * object cache associated with the attachment ID.
   *
   * This function will not run if $_wp_suspend_cache_invalidation is not empty. See
***************
*** 4665,4671 ****
   * Determines which fields of posts are to be saved in revisions.
   *
   * Does two things. If passed a post *array*, it will return a post array ready
!  * to be insterted into the posts table as a post revision. Otherwise, returns
   * an array whose keys are the post fields to be saved for post revisions.
   *
   * @package WordPress
--- 4666,4672 ----
   * Determines which fields of posts are to be saved in revisions.
   *
   * Does two things. If passed a post *array*, it will return a post array ready
!  * to be inserted into the posts table as a post revision. Otherwise, returns
   * an array whose keys are the post fields to be saved for post revisions.
   *
   * @package WordPress
***************
*** 5190,5200 ****
  }
  
  /**
   * Returns a link to a post format index.
   *
   * @since 3.1.0
   *
!  * @param $format string Post format
   * @return string Link
   */
  function get_post_format_link( $format ) {
--- 5191,5216 ----
  }
  
  /**
+  * Removes a post thumbnail.
+  *
+  * @since 3.3.0
+  *
+  * @param int|object $post Post ID or object where thumbnail should be removed from.
+  * @return bool True on success, false on failure.
+  */
+ function delete_post_thumbnail( $post ) {
+ 	$post = get_post( $post );
+ 	if ( $post )
+ 		return delete_post_meta( $post->ID, '_thumbnail_id' );
+ 	return false;
+ }
+ 
+ /**
   * Returns a link to a post format index.
   *
   * @since 3.1.0
   *
!  * @param string $format Post format
   * @return string Link
   */
  function get_post_format_link( $format ) {
***************
*** 5217,5223 ****
  	if ( isset( $slugs[ $qvs['post_format'] ] ) )
  		$qvs['post_format'] = 'post-format-' . $slugs[ $qvs['post_format'] ];
  	$tax = get_taxonomy( 'post_format' );
! 	$qvs['post_type'] = $tax->object_type;
  	return $qvs;
  }
  add_filter( 'request', '_post_format_request' );
--- 5233,5240 ----
  	if ( isset( $slugs[ $qvs['post_format'] ] ) )
  		$qvs['post_format'] = 'post-format-' . $slugs[ $qvs['post_format'] ];
  	$tax = get_taxonomy( 'post_format' );
! 	if ( ! is_admin() )
! 		$qvs['post_type'] = $tax->object_type;
  	return $qvs;
  }
  add_filter( 'request', '_post_format_request' );
***************
*** 5295,5298 ****
--- 5312,5331 ----
  }
  add_filter( 'wp_get_object_terms', '_post_format_wp_get_object_terms' );
  
+ /**
+  * Update the custom taxonomies' term counts when a post's status is changed. For example, default posts term counts (for custom taxonomies) don't include private / draft posts.
+  *
+  * @access private
+  * @param string $new_status
+  * @param string $old_status
+  * @param object $post
+  * @since 3.3.0
+  */
+ function _update_term_count_on_transition_post_status( $new_status, $old_status, $post ) {
+ 	// Update counts for the post's terms.
+ 	foreach ( (array) get_object_taxonomies( $post->post_type ) as $taxonomy ) {
+ 		$tt_ids = wp_get_object_terms( $post->ID, $taxonomy, array( 'fields' => 'tt_ids' ) );
+ 		wp_update_term_count( $tt_ids, $taxonomy );
+ 	}
+ }
  ?>
